;---------------------------------------------------------------------------------
;|        Programa, randanti nurodyta (pagal eiles numeri) pirmini skaiciu.      |
;---------------------------------------------------------------------------------

.model small	    		;programai reikia nedaug atminties
	
.386						;naudojami 32-bitu registrai

.code						;kodo segmentas

		mov cl,10			;isidedam 10 i CL tam, kad paskui galetumem dauginti is 10 
		mov si,82h			;gaunami komandines eilutes parametrai

;-------------------------------------------------------------------------------------------------------------------------

getch:	lodsb				;uzkraunamas baitas (loads byte)	
	
		cmp al,0dh			;tikrinama, ar ne ENTER (ar patikrinti visi simboliai komandinej eilutej)
		je eina 			;jei visi, nusokama i eina (EBX = komandines eilutes reiksme)
		
		sub al,30h			;simbolis verciamas skaiciumi
		
		xchg ebx,eax		;sukeiciamos registru EBX ir EAX reiksmes
		mul ecx     		;sudauginamos registru EAX ir ECX reiksmes (rezultatas irasomas i EAX) //MUL Op, EDX:EAX:=EAX*Op, jei EDX=0
		add ax,bx			;sudedamos AX ir BX registru reiksmes (rezultatas irasomas i AX)
		xchg ebx,eax		;sukeiciamos registru EBX ir EAX reiksmes
		
		jmp getch			;nusokama i getch (tam, kad butu imamas kitas simbolis is komandines eilutes)

;-------------------------------------------------------------------------------------------------------------------------

eina:	mov cl,2			;paimamas pirmas pirminis skaicius = 2
		push ecx			;ir patalpinamas i steka		
		dec bx				;BX reiksme sumazinama vienetu
		jz lab				;jeigu BX=0, vadinasi, rastas reikiamas pirminis skaicius, todel nusokama spausdint
		
		mov ebp,esp			;ESP reiksme nukopijuojama i EBP
		
		inc cx				;paimamas antras pirminis skaicius = 3
		push ecx			;ir patalpinamas i steka		
		dec bx				;BX reiksme sumazinama vienetu
		jz lab				;jeigu BX=0, vadinasi, rastas reikiamas pirminis skaicius, todel nusokama spausdint
		
;-------------------------------------------------------------------------------------------------------------------------
	
L1:		add ecx,2			;prie ECX reiksmes pridedami 2 (tikrinami tik nelyginiai skaiciai, didesni arba = 5)
        push ecx			;skaicius idedamas i steka
        
        fild dword ptr [esp]	;imamas sveikas skaicius, i kuri rodo ESP (tas skaicius = ECX), ir paverciamas i realuji skaiciu
        fsqrt					;ir istraukiama kvadratine saknis
        fistp dword ptr [esp]	;rezultatas paverciamas i sveika skaiciu
        
        pop edi				;paimamas skaicius EDI (sveikas skaicius, gautas istraukus kvadratine sakni)
        
		mov esi, -1			;prilyginam ESI = 0xFFFFFFFF 
        
;-------------------------------------------------------------------------------------------------------------------------

L2:		cmp edi,dword ptr [esi*4+ebp]	;lyginama EDI reiksme su pirminiu skaiciumi is steko
        jl radom			;jei EDI < pirmini skaiciu, radome nauja pirmini skaiciu (ECX)
        
		mov eax,ecx			;ECX reiksme (tikrinamas skaicius) nukopijuojama i EAX registra		
        mov edx,0       	;EDX registrui priskiriamas 0 (tam, kad veliau galetumem nustatyt, ar ECX yra pirminis skaicius)
        div dword ptr [esi*4+ebp]	;EAX reiksme dalinama is pirminio skaiciaus is steko //DIV Op, EAX:=EDX:EAX/Op, EDX:=liekana
                
        dec si				;SI reiksme sumazinama vienetu (rodys i kita pirmini skaiciu)
        
        cmp edx,0			;tikrinama, ar EDX reiksme (liekana) lygi 0
        je L1 				;jei lygi, nusokama i L1 (vadinasi, ECX nera pirminis skaicius, nes pasidalino is pirminio be liekanos)
		
		jmp L2        		;jei nelygi, nusokama i L2, kur ECX bus tikrinamas su kitu pirminiu skaiciumi is steko 

;-------------------------------------------------------------------------------------------------------------------------
        
radom:	cmp sp,60000		;lyginamas sp su 60000 (tik pirmus 5535-is pirminius skaicius talpiname i steka)
		jl nepush			;jei sp maziau uz 60000, nusokama i nepush
		
		push ecx			;talpinam pirmini skaiciu i steka
		
;-------------------------------------------------------------------------------------------------------------------------
		
nepush: dec ebx				;EBX reiksme mazinama vienetu
		jnz L1				;jeigu EBX nelygu 0, nusokama i L1, kur bus imamas kitas skaicius tikrinimui, ar jis pirminis

;-------------------------------------------------------------------------------------------------------------------------

lab:	mov eax,ecx			;pirminis skaicius ECX nukopijuojamas i EAX registra
		mov bx,89h			;registrui BX priskiriama 89h
		mov byte ptr [bx],24h	;padedamas eilutes pabaigos simbolis ($)
		dec bx				;BX sumazinamas vienetu
		mov ecx,0			;ECX prisilyginamas 0
		mov cl,10			;registrui CL priskiriama 10 (tam, kad paskui butu galima dalinti is 10)

;-------------------------------------------------------------------------------------------------------------------------
	
L3:		mov edx,0			;EDX registro reiksme priskiriama 0
		div ecx				;EAX reiksme dalinama is ECX //DIV Op, EAX:=EDX:EAX/Op, EDX:=liekana
		add dl,30h			;skaicius verciamas simboliumi
		mov byte ptr [bx],dl	;simboliai spausdinami nuo galo, todel pradedama nuo liekanos
		dec bx				;BX sumazinamas vienetu
		cmp bl,81h			;tikrinama, ar dar ne pabaiga spausdinimui
		jae L3				;jei ne, nusokama i L3

		mov ah,9			;kreipiamasi spausdinimui
    	mov dl,81h			;uzkraunamas rezultatas
    	int 21h         	;pertraukimas
    	
    	mov ah,4ch			;valdymas perduodamas operacinei sistemai    	
        int 21h             ;pertraukimas

end 

